/* test */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <math.h>
#include <string.h>
#include "odicon.h"
#include "lseparable.h"


static struct lseparable_st *lseparable_inst;
static double ffunc(int dim, double x[]) { return lseparable(dim, x, lseparable_inst); }
/*static double ifunc(int dim, int x[]) { return int_func(dim, ffunc, x); }*/
static double ifunc(int dim, int x[]) { return intint_func(dim, ffunc, x); }

void test_lconv3(const int dim, int argc, char** argv) {
    int i;
    double *fans = fvector_new(dim, 190, -200, 200);
    int    *init = ivector_new(dim, 190, -200, 200); /* starting point */

    for (i=0; i<dim; i++) {
        fans[i] = init[i] = irandom(-10*dim, +10*dim);
    }
    /*
    {int data[] = {-19, -14, 33, -29};
    for (i=0; i<dim; i++) init[i] = data[i];}
    */

    lseparable_inst = lseparable_make(dim);
#ifdef DEBUG    
    lseparable_output(lseparable_inst);
#endif /* DEBUG */

    if (strncmp(argv[3],"sc",2)==0) {
        if (strcmp(argv[4],"IFF")==0) {
            printf("スケーリング:IFF\n");
            lgconv_minimize_scaling_IFF(dim, ifunc, init);
        } else if (strcmp(argv[4],"FW")==0) {
            printf("スケーリング:FW\n");
            lgconv_minimize_scaling_FW(dim, ifunc, init);
        } else {
            printf("スケーリング:naive\n");
            lgconv_minimize_scaling(dim, ifunc, init);
        }
    } else if (strncmp(argv[3],"re",2)==0) {
        lbfgs_call(dim, ffunc, fans);
        for (i=0; i<dim; i++) init[i] = (int)floor(0.5 + fans[i]);
        if (strcmp(argv[4],"IFF")==0) {
            printf("連続緩和:IFF\n");
            lgconv_minimize_IFF(dim, ifunc, init);
        } else if (strcmp(argv[4],"FW")==0) {
            printf("連続緩和:FW\n");
            lgconv_minimize_FW(dim, ifunc, init);
        } else {
            printf("連続緩和:naive\n");
            lgconv_minimize(dim, ifunc, init);
        }
    } else {
        if (strcmp(argv[4],"IFF")==0) {
            printf("最急降下:IFF\n");
            lgconv_minimize_IFF(dim, ifunc, init);
        } else if (strcmp(argv[4],"FW")==0) {
            printf("最急降下:FW\n");
            lgconv_minimize_FW(dim, ifunc, init);
        } else {
            printf("最急降下:naive\n");
            lgconv_minimize(dim, ifunc, init);
        }
    }
    /*test(dim, ifunc, ians, init, limit);*/
}
